import { ListResponse } from "../types";
import { CreateObjectParams, ListObjectParams, UpdateObjectParams, DeleteObjectParams, BaseWarrantObject, WarrantObject, WarrantObjectLiteral } from "../types/Object";
import { WarrantRequestOptions } from "../types/WarrantRequestOptions";
export default class ObjectModule {
    static create(params: CreateObjectParams, options?: WarrantRequestOptions): Promise<BaseWarrantObject>;
    static batchCreate(params: CreateObjectParams[], options?: WarrantRequestOptions): Promise<BaseWarrantObject[]>;
    static get(object: WarrantObject | WarrantObjectLiteral, options?: WarrantRequestOptions): Promise<BaseWarrantObject>;
    static list(listParams: ListObjectParams, options?: WarrantRequestOptions): Promise<ListResponse<BaseWarrantObject>>;
    static update(object: WarrantObject | WarrantObjectLiteral, params: UpdateObjectParams, options?: WarrantRequestOptions): Promise<BaseWarrantObject>;
    static delete(object: WarrantObject | WarrantObjectLiteral, options?: WarrantRequestOptions): Promise<string>;
    static batchDelete(params: DeleteObjectParams[], options?: WarrantRequestOptions): Promise<string>;
}
