import { CreatePricingTierParams, ListPricingTierParams, ListFeatureParams, ListResponse, UpdatePricingTierParams, Warrant, FeatureCheckParams, WarrantObject } from "../types";
import Feature from "./Feature";
import { WarrantRequestOptions } from "../types/WarrantRequestOptions";
export default class PricingTier implements WarrantObject {
    pricingTierId: string;
    meta?: {
        [key: string]: any;
    };
    constructor(pricingTierId: string, meta: {
        [key: string]: any;
    });
    static create(pricingTier?: CreatePricingTierParams, options?: WarrantRequestOptions): Promise<PricingTier>;
    static get(pricingTierId: string, options?: WarrantRequestOptions): Promise<PricingTier>;
    static update(pricingTierId: string, params: UpdatePricingTierParams, options?: WarrantRequestOptions): Promise<PricingTier>;
    static delete(pricingTierId: string, options?: WarrantRequestOptions): Promise<string>;
    static listPricingTiers(listParams?: ListPricingTierParams, options?: WarrantRequestOptions): Promise<ListResponse<PricingTier>>;
    static listPricingTiersForTenant(tenantId: string, listParams?: ListPricingTierParams, options?: WarrantRequestOptions): Promise<ListResponse<PricingTier>>;
    static assignPricingTierToTenant(tenantId: string, pricingTierId: string, options?: WarrantRequestOptions): Promise<Warrant>;
    static removePricingTierFromTenant(tenantId: string, pricingTierId: string, options?: WarrantRequestOptions): Promise<string>;
    static listPricingTiersForUser(userId: string, listParams?: ListPricingTierParams, options?: WarrantRequestOptions): Promise<ListResponse<PricingTier>>;
    static assignPricingTierToUser(userId: string, pricingTierId: string, options?: WarrantRequestOptions): Promise<Warrant>;
    static removePricingTierFromUser(userId: string, pricingTierId: string, options?: WarrantRequestOptions): Promise<string>;
    listFeatures(listParams?: ListFeatureParams, options?: WarrantRequestOptions): Promise<ListResponse<Feature>>;
    assignFeature(featureId: string, options?: WarrantRequestOptions): Promise<Warrant>;
    removeFeature(featureId: string, options?: WarrantRequestOptions): Promise<string>;
    hasFeature(params: FeatureCheckParams, options?: WarrantRequestOptions): Promise<boolean>;
    getObjectType(): string;
    getObjectId(): string;
}
